from pyrsvp.rsvpclient import RsvpClientSerial
from pyrsvp.rsvptypes import *

# To emulate serial ports run the following command: 
# socat -d -d pty,raw,echo=0 pty,raw,echo=0

def test_cb(args : dict):
    print(args)

if __name__ == "__main__":

    client = RsvpClientSerial("/dev/pts/9", baud=9600)

    args = [
        RsvpInteger("ARG1", 1),
        RsvpDouble("ARG2", 2.0),
        RsvpBool("ARG3", True),
        RsvpString("ARG4", "hello world"),
        RsvpVectorDouble("ARG5", {"X": 1.0, "Y": 2.0, "Z": 3.0}),
        RsvpStringVector("ARG6", ["Hello", "World"])
    ]

    try:
        print(client.send_command("TEST", args))
    except Exception as ex:
        print(f"[{type(ex).__name__}] Error: {ex}")