from pyrsvp.rsvpserver import RsvpServer, RsvpServerTcp
from pyrsvp.rsvptypes import *
import argparse

#Define commands and their callbacks

# @RsvpServer.Command("EXCEPTION")
def handle_exception(ex : Exception) -> str:
    
    error =f"{type(ex).__name__} {ex}"

    try:
        raise ex
    except Exception as ex:
        print(f"{type(ex).__name__}: {ex}")

    return RsvpServer.reply(False, [RsvpString("ERROR", error)])

@RsvpServer.Command("START")
def start(values : dict) -> str:
    
    print(values)

    return RsvpServer.reply(True)


if __name__ == "__main__":

    parser = argparse.ArgumentParser(
        prog="Tcp Server",
        description="This is a TCP server for RSVP"
    )

    parser.add_argument("-p", "--port", help="Port used by the server")

    args = parser.parse_args()

    port = 55000

    if args.port:
        port  = int(args.port)

    srv = RsvpServerTcp("", port)
    srv.run()
